const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const jobs = sequelize.define(
    'jobs',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,

      },

job_number: {
        type: DataTypes.TEXT,

      },

job_name: {
        type: DataTypes.TEXT,

      },

status: {
        type: DataTypes.ENUM,

        values: [

"New",

"In Production",

"Completed",

"Cancelled"

        ],

      },

scheduled_completion_date: {
        type: DataTypes.DATE,

      },

job_type: {
        type: DataTypes.TEXT,

      },

total_cost: {
        type: DataTypes.DECIMAL,

      },

invoiced: {
        type: DataTypes.DECIMAL,

      },

uninvoiced: {
        type: DataTypes.DECIMAL,

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  jobs.associate = (db) => {

    db.jobs.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.jobs.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return jobs;
};

